
#include <board.h>
/* @BEGIN-MAN

\routine{ int bdSRQstat()  }
\synopsis{  }
\description{ Return the 'ibsta' status of the SRQ line. }
\returns{   }
\bugs{   }

   @END-MAN */

/*
 * BDSRQSTAT
 * Return the 'ibsta' status of the SRQ line.
 */
IBLCL bdSRQstat()
{
	int	result;

	DBGin("bdSRQstat");
	result = (GPIBin(isr3) & HR_SRQI_CIC) ? SRQI : 0;
	DBGout();
	return result;
}

/* @BEGIN-MAN

\routine{  bdsc()  }
\synopsis{  }
\description{ Enable System Controller state. }
\returns{   }
\bugs{   }

   @END-MAN */

/*
 * BDSC
 * Enable System Controller state.
 */
IBLCL bdsc()
{
	DBGin("bdsc");
	GPIBout(cmdr, SETSC);		/* set system controller */
	DBGout();
}

/* @BEGIN-MAN

\routine{  bdGetDataByte()  }
\synopsis{  }
\description{ get last byte from bus }
\returns{   }
\bugs{   }

   @END-MAN */

/* -- bdGetDataByte()
 * get last byte from bus
 */
IBLCL bdGetDataByte(void){
  DBGin("bdGetDataByte");
  return GPIBin(dir);
  DBGout();
}

/* @BEGIN-MAN

\routine{ bdGetCmdByte()  }
\synopsis{  }
\description{  get last Cmd byte from bus }
\returns{   }
\bugs{   }

   @END-MAN */
/* -- bdGetCmdByte()
 * get last Cmd byte from bus
 */

IBLCL bdGetCmdByte(void){
  DBGin("bdGetCmdByte");
  DBGout();
  return (GPIBin(cptr));
}

/* @BEGIN-MAN

\routine{  bdGetAdrStat()  }
\synopsis{  }
\description{ get address status  }
\returns{   }
\bugs{   }

   @END-MAN */
/* -- bdGetAdrStat()
 * get address status
 */

IBLCL bdGetAdrStat(void){
  DBGin("bdGetAdrStatus");
  DBGout();
  return (GPIBin(adsr));
}


/* @BEGIN-MAN

\routine{bdCheckEOI(void)   }
\synopsis{  }
\description{ Checks if EOI is set in adr1 }
\returns{   }
\bugs{   }

   @END-MAN */
/* -- bdCheckEOI()
 * Checks if EOI is set in adr1
 *
 */

IBLCL bdCheckEOI(void){
  DBGin("bdCheckEOI");
  DBGout();
  return ( GPIBin(adr1) & HR_EOI );
}


/* @BEGIN-MAN

\routine{ bdSetEOS(eos)  }
\synopsis{  }
\description{ set eos byte }
\returns{   }
\bugs{   }

   @END-MAN */


/* -- bdSetEOS(eos)
 * set eos byte
 *
 */

IBLCL bdSetEOS(int ebyte){
  DBGin("bdSetEOS");
  GPIBout(eosr, ebyte);
  DBGout();
}


/* @BEGIN-MAN

\routine{  bdSetSPMode(reg)  }
\synopsis{  }
\description{ Sets Serial Poll Mode }
\returns{   }
\bugs{   }

   @END-MAN */


/* -- bdSetSPMode(reg)
 * Sets Serial Poll Mode
 *
 */

IBLCL bdSetSPMode(int v){
  DBGin("bdSetSPMode");
	GPIBout(spmr, 0);		/* clear current serial poll status */
	GPIBout(spmr, v);		/* set new status to v */
  DBGout();
}



/* @BEGIN-MAN

\routine{  bdSetPAD(reg)  }
\synopsis{  }
\description{ Sets PAD of Controller }
\returns{   }
\bugs{   }

   @END-MAN */


/* -- bdSetPAD(reg)
 * Sets PAD of Controller
 *
 */

IBLCL bdSetPAD(int v){
  DBGin("bdSetPAD");
  GPIBout(adr,( v & LOMASK ));
  DBGout();
}

/* @BEGIN-MAN

\routine{  bdSetSAD()  }
\synopsis{  }
\description{ Sets SAD of Controller }
\returns{   }
\bugs{   }

   @END-MAN */


/* -- bdSetSAD()
 * Sets SAD of Controller
 *
 */

IBLCL bdSetSAD(int mySAD,int enable){
  DBGin("bdSetSPMode");
  if(enable){
    DBGprint(DBG_DATA, ("sad=0x%x  ", mySAD));
    GPIBout(adr, HR_ARS | (mySAD & LOMASK));
    GPIBout(admr, HR_TRM1 | HR_TRM0 | HR_ADM1);
  } else {
    GPIBout(adr, HR_ARS | HR_DT | HR_DL);
    GPIBout(admr, HR_TRM1 | HR_TRM0 | HR_ADM0);
  }
  DBGout();
}



