#include <board.h>
/* @BEGIN-MAN

\routine{  bdwait(unsigned int mask)  }
\synopsis{  }
\description{  Wait for a GPIB event to occur ('mask' must be non-zero).
 }
\returns{   }
\bugs{   }

   @END-MAN */

/*
 * BDWAIT
 * Wait for a GPIB event to occur ('mask' must be non-zero).
 */
IBLCL bdwait(mask)
unsigned int mask;
{
	uint8 s, imr2mask;

	DBGin("bdwait");
#if USEINTS
	if (!(pgmstat & PS_NOINTS)) {
		DBGprint(DBG_BRANCH, ("use ints  "));
		s = GPIBin(isr1);           /* clear ISRs by reading */
		s = GPIBin(isr2);
		imr2mask = 0;
		if (mask & SRQI)
			imr2mask |= HR_SRQIE;
		if (mask & (CIC | TACS | LACS))
			imr2mask |= HR_ACIE;
		DBGprint(DBG_DATA, ("imr2mask=0x%x  ", imr2mask));
		while (!(ibstat() & mask) && NotTimedOut()) {
			ibsta = CMPL;
			GPIBout(imr2, imr2mask);
			osWaitForInt(HR_TLCI);
			GPIBout(imr2, 0);   /* clear imr2 IE bits */
			s = GPIBin(isr2);   /* clear isr2 status bits */
			DBGprint(DBG_DATA, ("isr2=0x%x  ", s));
		}
	}
	else
#endif
	while (!(ibstat() & mask) && NotTimedOut())
		ibsta = CMPL;
	DBGout();
}

/***********************************************************************/



/* @BEGIN-MAN

\routine{  int bdWaitIn(void)  }
\synopsis{  }
\description{  Wait for Input }
\returns{   }
\bugs{   }

   @END-MAN */


/* -- int bdWaitIn(void)
 * Wait for Input
 *
 */

int bdWaitIn(void)
{
uint8 isreg1;
DBGin("bdWaitIn");
while (!((isreg1 = GPIBin(isr1)) & HR_DI) && NotTimedOut());
DBGout();
return isreg1;
}
/* @BEGIN-MAN

\routine{ bdWaitOut(void)  }
\synopsis{  }
\description{ Wait for Output  }
\returns{   }
\bugs{   }

   @END-MAN */

/* -- bdWaitOut(void)
 * Wait for Output 
 *
 */

bdWaitOut(void)
{
DBGin("bdWaitOut");
while (!(GPIBin(isr2) & HR_CO) && NotTimedOut());
DBGout();
}


/* @BEGIN-MAN

\routine{  bdWaitATN(void)  }
\synopsis{  }
\description{ Wait for *ATN }
\returns{   }
\bugs{   }

   @END-MAN */

/* -- bdWaitATN(void)
 * Wait for *ATN
 *
 */

bdWaitATN(void){
DBGin("bdWaitATN");
while ((GPIBin(adsr) & HR_NATN) && NotTimedOut());
DBGout();
}











