
#include <board.h>

/*
 * BDSRQSTAT
 * Return the 'ibsta' status of the SRQ line.
 */
IBLCL bdSRQstat()
{
	int	result;

	DBGin("bdSRQstat");
#if 0
	result = (GPIBin(isr3) & HR_SRQI_CIC) ? SRQI : 0;
#endif
/*@@*/
	result = (GPIBin(isr2) & HR_SRQI) ? SRQI : 0;
        /*result=0;*/       
         /* quick and dirty hack */
	DBGout();
	return result;
}


/*
 * BDSC
 * Enable System Controller state.
 */
IBLCL bdsc()
{
	DBGin("bdsc");
/*	GPIBout(cmdr, SETSC);	*/	/* set system controller */
	DBGout();
}


/* -- bdGetDataByte()
 * get last byte from bus
 */
IBLCL bdGetDataByte(void){
  DBGin("bdGetDataByte");
  return GPIBin(dir);
  DBGout();
}

/* -- bdGetCmdByte()
 * get last Cmd byte from bus
 */

IBLCL bdGetCmdByte(void){
  DBGin("bdGetCmdByte");
  DBGout();
  return (GPIBin(cptr));
}

/* -- bdGetAdrStat()
 * get address status
 */

IBLCL bdGetAdrStat(void){
  DBGin("bdGetAdrStatus");
  DBGout();
  return (GPIBin(adsr));
}


/* -- bdCheckEOI()
 * Checks if EOI is set in adr1
 *
 */

IBLCL bdCheckEOI(void){
  DBGin("bdCheckEOI");
  DBGout();
  return ( GPIBin(adr1) & HR_EOI );
}

/* -- bdSetEOS(eos)
 * set eos byte
 *
 */

IBLCL bdSetEOS(int ebyte){
  DBGin("bdSetEOS");
  GPIBout(eosr, ebyte);
  DBGout();
}




/* -- bdSetSPMode(reg)
 * Sets Serial Poll Mode
 *
 */

IBLCL bdSetSPMode(int v){
  DBGin("bdSetSPMode");
	GPIBout(spmr, 0);		/* clear current serial poll status */
	GPIBout(spmr, v);		/* set new status to v */
  DBGout();
}


/* -- bdSetPAD(reg)
 * Sets PAD of Controller
 *
 */

IBLCL bdSetPAD(int v){
  DBGin("bdSetPAD");
  GPIBout(adr,( v & LOMASK ));
  DBGout();
}

/* -- bdSetSAD()
 * Sets SAD of Controller
 *
 */

IBLCL bdSetSAD(int mySAD,int enable){
  DBGin("bdSetSPMode");
  if(enable){
    DBGprint(DBG_DATA, ("sad=0x%x  ", mySAD));
    GPIBout(adr, HR_ARS | (mySAD & LOMASK));
    GPIBout(admr, HR_TRM1 | HR_TRM0 | HR_ADM1);
  } else {
    GPIBout(adr, HR_ARS | HR_DT | HR_DL);
    GPIBout(admr, HR_TRM1 | HR_TRM0 | HR_ADM0);
  }
  DBGout();
}
