
#include <ibprot.h>


/*
 * IBPOKE
 * Undocumented, low-level driver control.  Includes turning
 * on and off different combinations of DEBUG statements.
 */
ibpoke(mask)
int mask;
{
	int	pkcode;
	int	pkvalue;
	char  * mesgp;

	pkcode  = mask & PK_CODE;
	pkvalue = mask & PK_VALUE;

	switch (pkcode) {
#if DEBUG
	case PK_DEBUG:
		mesgp = "New debug mask for ESP488: ";
		dbgMask = pkvalue;
		break;
#endif
#if USEINTS
	case PK_USEINTS:
		mesgp = "New interrupt setting for ESP488: ";
		if (pkvalue)
			pgmstat &= ~PS_NOINTS;
		else
			pgmstat |= PS_NOINTS;

		break;
#endif
	case PK_IFCDELAY:
		mesgp = "New IFC delay factor for ESP488: ";
		ifcDelay = pkvalue;
		break;
	case PK_POLLTIMO:
		if ((pkvalue < TNONE) || (pkvalue > T1000s))
			mesgp = "INVALID POLLTIMO VALUE: ";
		else {
			mesgp = "New 'poll' timeout index for ESP488: ";
			pollTimeidx = pkvalue;
		}
		break;
#if DMAOP
	case PK_ENABMEM:		/* enable system memory for DMA xfers */
		osEnabMem();
		mesgp = "Memory ENABLED\n";
		break;
#endif
	case PK_EOSMODE:
		mesgp = "New 'END with EOS' mode for ESP488: ";
		if (pkvalue)
			pgmstat &= ~PS_NOEOSEND;
		else
			pgmstat |= PS_NOEOSEND;

		break;
	case PK_INFO:
		mesgp = "New poke info setting for ESP488: ";
		if (pkvalue)
			pgmstat &= ~PS_SILENT;
		else
			pgmstat |= PS_SILENT;

		break;
	default:
		mesgp = "INVALID POKE CODE: ";
		pkvalue = pkcode;
		break;
	}
	if (!(pgmstat & PS_SILENT))
		osPrint("%s%d (0x%x)\n", mesgp, pkvalue, pkvalue);
}
