/*
 * ibtest.c
 * test module for gpib esp driver
 * 
 * 
 *
 */

#define USE_SRQ 1

#include <stdio.h>
#include <ib.h>

extern int ibXsta,ibXcnt,ibXerr;

char spr;
char cmd[130];
char res[1024];

main(int argc,char **argv){

  register i=0;
  char spr;
  int dev;
  char eosbyte = 0x0a;

/*
  if((dev = ibXconfig(0x2c0,10,1)) & ERR){
    gpiberr("ibconf err");
    exit(1);
  }
*/


  if((dev = ibfind("voltmeter")) & ERR){
    gpiberr("ibfind err");
    exit(1);
  }


  printf("\nsend IFC");
  if( ibsic(dev) & ERR ){
    gpiberr("ibsic Err");
    exit(1);

  }

  printf("\nset REM");
  if( ibsre(dev,1) & ERR ){
    gpiberr("ibsre err");
    exit(1);
  }

  printf("\nclear device..");
  if(ibclr(dev) & ERR){
    gpiberr("clr err");
    exit(1);
  }


  printf("\nsend nice string..");
  strcpy(cmd,"D1 Init_Device");
  if( ibwrt(dev,cmd,strlen(cmd)) & ERR ){
    gpiberr("wrt err");
    exit(1);
  }

  printf("\nsetup Device");
#if USE_SRQ
  strcpy(cmd,"D0 L0 Q1 T1 R2 A1 S0");
#else
  strcpy(cmd,"D0 L0 Q0 T1 R2 A1 S0");
#endif
  if( ibwrt(dev,cmd,strlen(cmd)) & ERR ){
    gpiberr("wrt err");
    exit(1);
  }
#if 0
  printf("\nTesting raw mode");

  printf("\nUnlisten,untalk");
  cmd[0] = UNL;
  cmd[1] = UNT;
  if( ibXcmd(cmd,2L) & ERR ){
    gpiberr("unl unt falsch");
    exit(1);
  }

  printf("\nSet talker and listener");
  cmd[0] = 7 | TAD;  /* set talker to device */
  cmd[1] = 0   | LAD ;  /* listener to host */
  if( ibXcmd(cmd,2L) & ERR ){
    gpiberr("TAD-LAD falsch");
    exit(1);
  }

  printf("\nWaiting for SRQ...");
  if( ibwait(dev,TIMO|SRQI) & (ERR |TIMO)){
    gpiberr("ibwait Error");
    exit(1);
  }
  printf("OK GOT IT");

  if( ibXrd(res,6) & ERR){
    printf("\n Warning, error occured!");
  }
  res[ibXcnt]=0;
  printf("\nres='%s' cnt=%d\n",res,ibXcnt);
  if( ibXrd(res,15) & ERR){
    printf("\n Warning, error occured!");
  }
  res[ibXcnt]=0;
  printf("\nres='%s' cnt=%d\n",res,ibXcnt);

  printf("\nUnlisten,untalk");
  cmd[0] = UNL;
  cmd[1] = UNT;
  if( ibcmd(dev,cmd,2L) & ERR ){
    gpiberr("unl unt falsch");
    exit(1);
  }

#endif

for(i=0;i<1;i++){

#if USE_SRQ
#if 0
  printf("\nWaiting for SRQ...");fflush(stdout);
  if( ibwait(dev,TIMO|SRQI) & (ERR |TIMO)){
    gpiberr("ibwait Error");
    /*exit(1);*/
  } else
  printf("OK GOT IT\n");fflush(stdout);

  
  if( ibrsp(dev, &spr) & ERR ){
    gpiberr("Serial Poll Error");
  }
  printf("\nSPB=0x%x\n",spr);fflush(stdout);
#endif

  printf("\nWaiting for RQS...");fflush(stdout);
  if( ibwait(dev,TIMO|RQS) & (ERR |TIMO)){
    gpiberr("ibwait Error");
    /*exit(1);*/
  } else
  printf("OK GOT IT\n");fflush(stdout);



#endif
  printf("\nReading Value...");

  if( ibrd(dev,res,1023) & ERR){
    printf("\n Warning, error occured!");
    gpiberr("read error");
  }
  res[ibXcnt]=0;
  printf("\nres='%s' cnt=%d\n",res,ibXcnt);
}



  printf("\nUnlisten,untalk");
  cmd[0] = UNL;
  cmd[1] = UNT;
  if( ibcmd(dev,cmd,2L) & ERR ){
    gpiberr("unl unt falsch");
    exit(1);
  }


  if( ibsre(dev,0) & ERR ){      /* unset rem */
    gpiberr("ibsre err");
    exit(1);
  }

  ibonl(dev,0);
}



gpiberr(char *msg) {




printf("%s\n",msg);

printf("ibsta=0x%x  <",ibXsta);

if ( ibXsta & ERR )  printf(" ERR");
if ( ibXsta & TIMO ) printf(" TIMO");
if ( ibXsta & END )  printf(" END");
if ( ibXsta & SRQI ) printf(" SRQI");
/*if ( ibXsta & RQS )  printf(" RQS");*/
if ( ibXsta & CMPL ) printf(" CMPL");
/*if ( ibXsta & LOK )  printf(" LOK");*/
/*if ( ibXsta & REM )  printf(" REM");*/
if ( ibXsta & CIC )  printf(" CIC");
if ( ibXsta & ATN )  printf(" ATM");
if ( ibXsta & TACS ) printf(" TACS");
if ( ibXsta & LACS ) printf(" LACS");
/*if ( ibXsta & DTAS ) printf(" DATS");*/
/*if ( ibXsta & DCAS ) printf(" DCTS");*/

printf(" >\n");

printf("iberr= %d", ibXerr);
if ( ibXerr == EDVR) printf(" EDVR <OS Error>\n");
if ( ibXerr == ECIC) printf(" ECIC <Not CIC>\n");
if ( ibXerr == ENOL) printf(" ENOL <No Listener>\n");
if ( ibXerr == EADR) printf(" EADR <Adress Error>\n");
if ( ibXerr == EARG) printf(" ECIC <Invalid Argument>\n");
if ( ibXerr == ESAC) printf(" ESAC <No Sys Ctrlr>\n");
if ( ibXerr == EABO) printf(" EABO <Operation Aborted>\n");
if ( ibXerr == ENEB) printf(" ENEB <No Gpib Board>\n");
if ( ibXerr == EOIP) printf(" EOIP <Async I/O in prg>\n");
if ( ibXerr == ECAP) printf(" ECAP <No Capability>\n");
if ( ibXerr == EFSO) printf(" EFSO <File sys. error>\n");
if ( ibXerr == EBUS) printf(" EBUS <Command error>\n");
if ( ibXerr == ESTB) printf(" ESTB <Status byte lost>\n");
if ( ibXerr == ESRQ) printf(" ESRQ <SRQ stuck on>\n");
if ( ibXerr == ETAB) printf(" ETAB <Table Overflow>\n");
if ( ibXerr == EPAR) printf(" EPAR <Parse Error in Config>\n");
if ( ibXerr == ECFG) printf(" ECFG <Can't open Config>\n");
if ( ibXerr == ETAB) printf(" ETAB <Device Table Overflow>\n");
if ( ibXerr == ENSD) printf(" ENSD <Configuration Error>\n");


printf("ibcnt= %d\n", ibXcnt );
printf("\n");


/*ibonl(0);*/
}
