
#include <ib.h>
#include <ibP.h>

#include <fcntl.h>

int ibXerr = 0;
int ibXsta = 0;
int ibXcnt = 0;

ibarg_t ibarg = {0 };


ibBoard_t ibBoard[MAX_BOARDS];

PRIVATE int ibBoardDefaultValues(void)
{
register i;
for(i=0;i<MAX_BOARDS;i++){

	ibBoard[i].padsad =0;					
	ibBoard[i].eos='\n';
	ibBoard[i].eosflags=0; 
	ibBoard[i].base=0;
	ibBoard[i].irq=0;
	ibBoard[i].dma=0;
	ibBoard[i].ifc=0;
	ibBoard[i].fileno=0;
	strcpy(ibBoard[i].device,"");
        strcpy(ibBoard[i].errlog,"");
      }
}

/**********************/
PRIVATE int ibBoardOpen(int bd)
{

int fd;

if( ibBoard[bd].fileno == 0 ){

  if( ( fd = open( ibBoard[bd].device, O_RDWR )) < 0 ){

    ibXsta =  ERR;
    ibXerr = EDVR;
    ibXcnt = errno;
    ibPutErrlog(-1,"ibBoardOpen");
    return ERR;
  }
  ibBoard[bd].fileno = fd;
}
return 0;
}

/**********************/
PRIVATE int ibBoardClose(int bd)
{

if( ibBoard[bd].fileno > 0 ){
  close( ibBoard[bd].fileno );
  ibBoard[bd].fileno = 0;
}
return 0;
}

/**********************/

_VARARGS int ibBoardFunc (int bd, int code, int arg, char *buf, int cnt)
{
#if HAS_RGPIB
  if( bd & UD_REMOTE ) {  /* board handle is a network request handle */
      /* do request */
      return ibRemoteFunc(bd,code,arg,buf,cnt);
  } 
  /**** local device operation ***/
#endif

  if( ibBoard[bd].fileno > 0 ){
    ibarg.ib_arg = arg;

    ibarg.ib_buf = (char *) buf;

    ibarg.ib_cnt = cnt;
    if( ioctl( ibBoard[bd].fileno, code, (ibarg_t *) &ibarg ) < 0){
      ibXsta = ERR;
      ibXerr = EDVR;
      ibXcnt = errno;
    } else {
      ibXsta = ibarg.ib_ibsta;
      ibXerr = ibarg.ib_iberr;
      ibXcnt = ibarg.ib_ibcnt;
      ibPutErrlog(-1,ibVerbCode(code));
    }
  } else {
    ibXsta = CMPL | ERR;
    ibXerr = ENEB;
    ibXcnt = 0;
  } 
  if(code == IBRD || code==DVRD ) strcpy(buf,ibarg.ib_buf);
  ibPutErrlog(-1,"ibBoardFunc");
  return ibXsta;
}


PRIVATE int ibGetNrBoards(void)
{
extern int bdid;
 
 return bdid+1;

}





